<?php

class ipay_payment_gateway extends WC_Payment_Gateway {

	function __construct() {

		// global ID
		$this->id = "ipay_payment_gateway";
		$this->separator="_IPAY_";
		// Show Title
		$this->method_title = __( "Interpay Payment Processor", 'ipay_payment_gateway' );

		// Show Description
		$this->method_description = __( "Interpayafrica Payment Gateway Plugin for WooCommerce", 'ipay_payment_gateway' );

		// vertical tab title
		$this->title = __( "Interpay Payment Processor", 'ipay_payment_gateway' );


		$this->icon = null;

		$this->has_fields = true;

		// support default form with credit card
		//$this->supports = array( 'default_credit_card_form' );

		// setting defines
		$this->init_form_fields();

		// load time variable setting
		$this->init_settings();
		$this->testmode = $this->get_option( 'environment' );
		 
		$this->$context = array( 'source' => 'ipay_payment_gateway' );
		// Turn these settings into variables we can use
		foreach ( $this->settings as $setting_key => $value ) {
			$this->$setting_key = $value;
		}
		
		// further check of SSL if you want
		add_action( 'admin_notices', array( $this,	'do_ssl_check' ) );
		
		// Save settings
		if ( is_admin() ) {
			add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
		}		
		add_action( 'woocommerce_api_ipay_callback', array( $this, 'ipay_callback' ) );
	} // Here is the  End __construct()
	public function ipay_callback() {
		$logger = wc_get_logger();
		//$logger->info("REQUEST_URI = ". $_SERVER['REQUEST_URI'], $this->$context );
		$ORDER_ID = explode($this->separator,$_GET['order_id'])[0];

		$order = wc_get_order($ORDER_ID);
		$status_code = $_GET['status_code'];
		$status_message = $_GET['status_message'];
		$trans_ref_no = $_GET['trans_ref_no'];
		$signature = $_GET['signature'];
		global $woocommerce;
		if ( !function_exists( 'wc_add_notice' ) ) { 
			    require_once '/includes/wc-notice-functions.php'; 
			} 
		if($status_code==1)
		{
			$order->payment_complete();
			$order->reduce_order_stock();
			$woocommerce->cart->empty_cart();
			update_option('webhook_debug', $_GET);
			$respMessage = 'Payment successful from Interpayafrica <br>order_id='.$ORDER_ID.", Interpayafrica Ref No = ".$trans_ref_no.", status_code = ".$status_code.",status_message = ".$status_message;
			$order->add_order_note($respMessage );

			wc_add_notice( sprintf( __( '%s payment Completed! Transaction ID: %d', 'woocommerce' ), $this->title, $trans_ref_no ), 'success' );
			$order_returl = $this->get_return_url( $order );

			header('Location: ' . $order_returl);
		}
		else
		{
		//	echo $_GET['status_message'];
			$respMessage = 'Payment Error from Interpayafrica <br>order_id='.$ORDER_ID.", Interpayafrica Ref No = ".$trans_ref_no.", status_code = ".$status_code.",status_message = ".$status_message;
			$logger->info("Response Message = ". $respMessage, $this->$context );
			$order->add_order_note($respMessage );
			//$order->update_status('failed', sprintf( __( '%s payment failed! Transaction ID: %d', 'woocommerce' ), $this->title, $trans_ref_no ) );
 			//header('Location: ' . $url, true, $permanent ? 301 : 302);
 			

 			$cart_url = $woocommerce->cart->get_cart_url();
 			
 			wc_add_notice( sprintf( __( '%s payment failed! Transaction ID: %d', 'woocommerce' ), $this->title, $trans_ref_no ), 'error' );
 			header('Location: ' . $cart_url);


    exit();
		}
	}
	public function payment_fields() {
	 
		// ok, let's display some description before the payment form
		if ( $this->description ) {
			// you can instructions for test mode, I mean test card numbers etc.
			if ( $this->testmode=='yes' ) {  
				$this->description .= ' <br><b>TEST MODE</b>';
				$this->description  = trim( $this->description );
			}
			// display the description with <p> tags etc.
			echo wpautop( wp_kses_post( $this->description ) );
		}
	 
		// I will echo() the form, but you can close PHP tags and print it directly in HTML
		echo '<fieldset id="wc-' . esc_attr( $this->id ) . '-cc-form" class="wc-credit-card-form wc-payment-form" style="background:transparent;">';
	 
		// Add this action hook if you want your custom gateway to support it
		//do_action( 'woocommerce_credit_card_form_start', $this->id );
	 
		// I recommend to use inique IDs, because other gateways could already use #ccNo, #expdate, #cvc
		//<div class="form-row form-row-wide">
		//<label>Customer Name <span class="required">*</span></label>
		//	<input id="ipay_cust_name" name="ipay_cust_name" type="text" autocomplete="off">
		//	</div>
		echo '<div class="form-row form-row-wide">
				<label>Customer Mobile<span class="required">*</span>(+233xxxxxxxxx)</label>
				<input id="ipay_cust_mobile" name="ipay_cust_mobile" type="text" autocomplete="off" maxlength="13" placeholder="+233xxxxxxxxx">
			</div>
			<div class="clear"></div>';
	 
		//do_action( 'woocommerce_credit_card_form_end', $this->id );
	 
		echo '<div class="clear"></div></fieldset>';
	 
	}
	public function validate_fields()
	{
		if(empty( $_POST[ 'ipay_cust_mobile' ])) {
			
			wc_add_notice(  'Customer Mobile is required.', 'error' );
			return false;
		}
		else 
		{
			if(!preg_match("/^\+[0-9]{12}$/", $_POST[ 'ipay_cust_mobile' ])) {
			  	wc_add_notice(  'Invalid Customer Mobile.', 'error' );
				return false;
			}
		}
		return true;
	 
	}
	// administration fields for specific Gateway
	public function init_form_fields() {
		$this->form_fields = array(
			'enabled' => array(
				'title'		=> __( 'Enable / Disable', 'ipay_payment_gateway' ),
				'label'		=> __( 'Enable this payment gateway', 'ipay_payment_gateway' ),
				'type'		=> 'checkbox',
				'default'	=> 'no',
			),
			'title' => array(
				'title'		=> __( 'Title', 'ipay_payment_gateway' ),
				'type'		=> 'text',
				'desc_tip'	=> __( 'Payment title of checkout process.', 'ipay_payment_gateway' ),
				'default'	=> __( 'Interpayafrica', 'ipay_payment_gateway' ),
			),
			'description' => array(
				'title'		=> __( 'Description', 'ipay_payment_gateway' ),
				'type'		=> 'textarea',
				'desc_tip'	=> __( 'Payment title of checkout process.', 'ipay_payment_gateway' ),
				'default'	=> __( 'Successfully payment through Interpayafrica.', 'ipay_payment_gateway' ),
				'css'		=> 'max-width:450px;'
			),
			'api_login' => array(
				'title'		=> __( 'Interpayafrica App ID', 'ipay_payment_gateway' ),
				'type'		=> 'text',
				'desc_tip'	=> __( 'This is the API App ID provided by Interpayafrica when you signed up for an account.', 'ipay_payment_gateway' ),
			),
			'trans_key' => array(
				'title'		=> __( 'Interpayafrica App Key', 'ipay_payment_gateway' ),
				'type'		=> 'password',
				'desc_tip'	=> __( 'This is the App Key provided by Interpayafrica when you signed up for an account.', 'ipay_payment_gateway' ),
			),
			'environment' => array(
				'title'		=> __( 'Interpayafrica Test/Live Mode', 'ipay_payment_gateway' ),
				'label'		=> __( 'Enable Test Mode', 'ipay_payment_gateway' ),
				'type'		=> 'checkbox',
				'description' => __( 'This is the test mode of gateway.', 'ipay_payment_gateway' ),
				'default'	=> 'no',
			)
		);		
	}
	
	// Response handled for payment gateway
	public function process_payment( $order_id ) {
		global $woocommerce;
		$logger = wc_get_logger();
		$customer_order = new WC_Order( $order_id );
		
		// checking for transiction
		$environment = ( $this->environment == "yes" ) ? 'TRUE' : 'FALSE';
		$Token_URL = "interapi/ProcessPayment";
		$REDIRECT_URL = "interapi/confirmpayment?Token=";
		// Decide which URL to post to
		$BASE_URL = ( "FALSE" == $environment ) 
                               ? 'https://www.interpayafrica.com/' //Live
						   : 'https://test.interpayafrica.com/';  // TEST

		//$logger->info("PAYLOAD = ". $this->get_return_url( $customer_order ), $this->$context );
		// This is where the fun stuff begins
		$payload = array(
			"app_id" => $this->api_login,
			"app_key" => $this->trans_key,
			"name" =>$customer_order->billing_first_name . $customer_order->billing_last_name,
			"mobile" =>$_POST['ipay_cust_mobile'],
			"email" => $customer_order->billing_email,
			"order_id" => $order_id . $this->separator . uniqid(),
			"currency" => "GHS",
			"amount" => $customer_order->order_total,
			"order_desc" => "Payment Of Order # " .$order_id." for Amount " .$customer_order->order_total,
			"return_url" => "http://localhost/WP/wc-api/ipay_callback",
			//"signature" => "asdf"
			// Authorize.net Credentials and API Info
			//"x_tran_key"           	=> $this->trans_key,
			//"x_login"              	=> $this->api_login,
			//"x_version"            	=> "3.1",
			
			// Order total
			//"x_amount"             	=> ,
			
			// Credit Card Information
			//"x_card_num"           	=> str_replace( array(' ', '-' ), '', $_POST['cwoa_authorizenet_aim-card-number'] ),
			//"x_card_code"          	=> ( isset( $_POST['cwoa_authorizenet_aim-card-cvc'] ) ) ? $_POST['cwoa_authorizenet_aim-card-cvc'] : '',
			//"x_exp_date"           	=> str_replace( array( '/', ' '), '', $_POST['cwoa_authorizenet_aim-card-expiry'] ),
			
			//"x_type"               	=> 'AUTH_CAPTURE',
			//"x_invoice_num"        	=> str_replace( "#", "", $customer_order->get_order_number() ),
			//"x_test_request"       	=> $environment,
			//"x_delim_char"         	=> '|',
			//"x_encap_char"         	=> '',
			///"x_delim_data"         	=> "TRUE",
			//"x_relay_response"     	=> "FALSE",
			//"x_method"             	=> "CC",
			
			// Billing Information
			//"x_first_name"         	=> $customer_order->billing_first_name,
			//"x_last_name"          	=> $customer_order->billing_last_name,
			//"x_address"            	=> $customer_order->billing_address_1,
			//"x_city"              	=> $customer_order->billing_city,
			//"x_state"              	=> $customer_order->billing_state,
			//"x_zip"                	=> $customer_order->billing_postcode,
			//"x_country"            	=> $customer_order->billing_country,
			//"x_phone"              	=> $customer_order->billing_phone,
			//"x_email"              	=> $customer_order->billing_email,
			
			// Shipping Information
			//"x_ship_to_first_name" 	=> $customer_order->shipping_first_name,
			//"x_ship_to_last_name"  	=> $customer_order->shipping_last_name,
			//"x_ship_to_company"    	=> $customer_order->shipping_company,
			///"x_ship_to_address"    	=> $customer_order->shipping_address_1,
			//"x_ship_to_city"       	=> $customer_order->shipping_city,
			//"x_ship_to_country"    	=> $customer_order->shipping_country,
			//"x_ship_to_state"      	=> $customer_order->shipping_state,
			//"x_ship_to_zip"        	=> $customer_order->shipping_postcode,
			
			// information customer
			//"x_cust_id"            	=> $customer_order->user_id,
			//"x_customer_ip"        	=> $_SERVER['REMOTE_ADDR'],
			
		);
		//$logger->info("PAYLOAD = ". implode($payload), $this->$context );
	
		// Send this payload to Authorize.net for processing
		 $response = wp_remote_post( $BASE_URL.$Token_URL, array(
		 	'method'    => 'POST',
		 	'body'      => http_build_query( $payload ),
		 	'timeout'   => 90,
		 	'sslverify' => false,
		 ) );
		//$logger->info(http_build_query($response), $this->$context );

		if ( is_wp_error( $response ) ) 
			throw new Exception( __( 'There is issue for connectin payment gateway. Sorry for the inconvenience.', 'ipay_payment_gateway' ) );
//
		if ( empty( $response['body'] ) )
			throw new Exception( __( 'Authorize.net\'s Response was not get any data.', 'ipay_payment_gateway' ) );
			
		// get body response while get not error
		$response_body = wp_remote_retrieve_body( $response );
		///$logger->info("RESPONSE BODY = ". $response_body, $this->$context );

		$resp = json_decode($response_body); 
		//$logger->info("parsed", $this->$context );

		//$logger->info("RESPONSE PARSED = ".  implode($resp), $this->$context );

		//foreach ( preg_split( "/\r?\n/", $response_body ) as $line ) {
		//	$resp = explode( "|", $line );
		//}

		//wc_add_notice( $response_body, 'error' );
		//$customer_order->add_order_note( 'Error: '. $response_body );
		// values get
		$r['status_code']= $resp->status_code;
		$r['status_message']= $resp->status_message;
		$r['trans_ref_no']= $resp->trans_ref_no;
		$r['Token']= $resp->Token;
		//$logger->info("RESPONSE = ". implode($r), $this->$context );

		//$logger->info("Response Array:=".implode($resp), $this->$context );

		//$logger->info("R Array". implode($r), $this->$context );
		 //   $logger->info("STATUS CODE=".$r['status_code'] , $this->$context );

		// 1 or 4 means the transaction was a success
		if ( ($r['status_code'] == "1") || ($r['status_code'] == 1) ) {
		    //$logger->info("Inside IF" , $this->$context );

			// Payment successful
		    //$customer_order->add_order_note( __( 'Authorize.net complete payment.', 'ipay_payment_gateway' ) );
												 
			// paid order marked
			//$customer_order->payment_complete();

			// this is important part for empty cart
			//$woocommerce->cart->empty_cart();
			$redurl = $BASE_URL.$REDIRECT_URL.urlencode($r['Token']);
		    //$logger->info("REDIRECT URL = ".$redurl, $this->$context );
			
			// Redirect to thank you page
			return array(
				'result'   => 'success',
				'redirect' => $redurl,
			);
		} else {
		  //  $logger->info("Inside ELSE IF" , $this->$context );
			//transaction fail
			wc_add_notice( $r['status_message']  , 'error' );
			$customer_order->add_order_note( 'Error: '. $r['status_message']  );
		}

	}

	public function do_ssl_check() {
		if( $this->enabled == "yes" ) {
			if( get_option( 'woocommerce_force_ssl_checkout' ) == "no" ) {
				echo "<div class=\"error\"><p>". sprintf( __( "<strong>%s</strong> is enabled and WooCommerce is not forcing the SSL certificate on your checkout page. Please ensure that you have a valid SSL certificate and that you are <a href=\"%s\">forcing the checkout pages to be secured.</a>" ), $this->method_title, admin_url( 'admin.php?page=wc-settings&tab=checkout' ) ) ."</p></div>";	
			}
		}		
	}
	

}